#include "globals.h"

namespace globals {
   std::map<unsigned char, bool> keys;
   std::map<int, bool> special_keys;

   bool warp_mouse = true;
   int elapsed_time = 0;

   namespace main_win {
      int width = 800;
      int height = 600;
      int pos_x = 100;
      int pos_y = 100;

      int handle = -1;
   }

   namespace cam {
      float pos_x = 0.0f;
      float pos_y = 3.0f;
      float pos_z = 5.0f;

      float ang_x = 0.0f;
      float ang_y = 0.0f;
      float ang_z = 0.0f;

      float near_plane_dist = 0.1f;
      float far_plane_dist = 100.0f;

      float field_of_view = 45.0f;
   }

   namespace light {
      float pos[] = {0, 5, 0, 0};
   }

   namespace shaders {
      int vshader = -1;
      int fshader = -1;
      int prog = -1;

      unsigned int bump_tex_handle = -1;
      unsigned int decal_tex_handle = -1;
   }
}
