#include <stdlib.h>

#include "gl_util.h"

#include "io.h"
#include "globals.h"
#include "consts.h"

using namespace consts;
using namespace globals;

void io::key_down(unsigned char key, int x, int y) {
   keys[key] = true;   

   if (key == ESC_KEY)
      exit(0);
}

void io::key_up(unsigned char key, int x, int y) {
   keys[key] = false;
}

void io::special_key_down(int key, int x, int y) {
   special_keys[key] = true;
}

void io::special_key_up(int key, int x, int y) {
   special_keys[key] = false;
}

void io::mouse_click(int button, int state, int x, int y) {
   // Stub for expansion
}

void io::mouse_motion(int x, int y) {
   x -= (main_win::width >> 1);
   y -= (main_win::height >> 1);

   if (warp_mouse) {
      cam::ang_y -= x * MOUSE_DELTA;
      cam::ang_x -= y * MOUSE_DELTA;
   }
}

void io::mouse_window(int state) {
   if (state == GLUT_LEFT)
      warp_mouse = false;
   else
      warp_mouse = true;
}
