#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

#include "util.h"

char* slurp_file(const char* path) {
   FILE* fp = NULL;
   char* ret = NULL;
   int size = 0;

   assert(path != NULL);

   fp = fopen(path, "r");
   if (fp == NULL) {
      perror("fopen -- slurp_file");
      exit(1);
   }

   fseek(fp, 0, SEEK_END);
   size = ftell(fp);
   rewind(fp);

   if (size > 0) {
      ret = (char*) malloc(sizeof(char) * (size + 1));
      size = fread(ret, sizeof(char), size, fp);
      ret[size] = '\0';
   }
   fclose(fp);
   return ret;
}
